/**************************************************************************************************
  RTC.h

  Copyright (C) 2015  Val Gretchev

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.

**************************************************************************************************/
#ifndef RTC_H
#define RTC_H


// Defines


// Time structure with am/pm
typedef struct Time {
     short ampm;
     short seconds;
     short minutes;
     short hours;
     short day;
     short month;
     int year;
} TTime;



// Function Prototypes
void RTC_Initialize(void);
void RTC_Write(TTime *RTCC_Time);
void RTC_Read(TTime *RTCC_Time);

void RTC_WriteSRAM(unsigned short Reg, unsigned long Value);
unsigned long RTC_ReadSRAM(unsigned short Reg);

void RTC_WriteCCR(char Cal);
void RTC_ReadCCR(void);
void SetTime(void);
void GetTime(void);
char* GetTimeStampStr(void);

#endif



/**************************************************************************************************
  End of File
**************************************************************************************************/