/**************************************************************************************************
  UART2ForFreeRTOS.h
**************************************************************************************************/
#ifndef UART2_DRIVER_H
#define UART2_DRIVER_H

// Defines
#define DC3 0x13         // XOFF control character
#define DC1 0x11         // XON control character
#define NUL 0x00         // NUL control character

#define U2_RCV_BUF_SIZE 256
#define U2_RCV_BYTE_Q_LENGTH 128

// Structures
typedef void (*tPointerFcn)(void);  // Pointer to a function


// Function Prototypes
void UART2_SetBaud(void);
void UART2_RxQueueInit(void);
void UART2_StartRx(void);
void UART2_RcvInit(void);
void UART2_Rx(void);
void UART2_Rx1(void);
void UART2_Rx2(void);

void UART2_PutQueue(char *msg);
void UART2_StartTx(void);
void UART2_SendMsg(char *s);
void UART2_Tx(void);


#endif


/**************************************************************************************************
  End of File
**************************************************************************************************/